using System.Collections.Generic;
using System;
using OSI.API.DAL.Client;

namespace OSI.API.DAL.Invoice
{
    public class InvoiceObject
    {
        public int InvoiceNumber { get; set; }
        public float InvoiceAmount { get; set; }
        public float Discount { get; set; }
        public float Tax { get; set; }
        public List<InvoiceObjectLineItems>? InvoiceLineItems { get; set; }
        public Notes? Notes { get; set; }
        public DateTime InvoiceDate { get; set; }
        public DateTime DueDate { get; set; }
        public ClientObject? Client { get; set; }
    }

    public class InvoiceObjectLineItems
    {
        public string? Item { get; set; }
        public string? Description { get; set; }
        public float Cost { get; set; }
        public float Quantity { get; set; }
        public float Tax { get; set; }
        //public float Total => ((Cost * Quantity) + ((Cost * Quantity) * (Tax / 100)));
        public float Total { get; set; }

    }

    public class Notes
    {
        public string? PublicNotes { get; set; }
        public string? PrivateNotes { get; set; }
        public string? Terms { get; set; }

    }
}